package org.wso2.carbon.application.deployer;

import org.osgi.framework.BundleListener;
import org.osgi.framework.BundleEvent;
import org.osgi.framework.Bundle;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * This class implements BundleListener and listens for new bundle additions. If app artifacts
 * are found, deploy them 
 */
public class AppDeployerBundleListener implements BundleListener {

    private static Log log = LogFactory.getLog(AppDeployerBundleListener.class);

    private static AppDeployerBundleListener instance = null;

    private ApplicationManager appManager;

    public AppDeployerBundleListener(ApplicationManager appManager) {
        this.appManager = appManager;
    }

    public static AppDeployerBundleListener getInstance(ApplicationManager appManager) {
        if (instance == null) {
            instance = new AppDeployerBundleListener(appManager);
        }
        return instance;
    }

    public void bundleChanged(BundleEvent bundleEvent) {
        try {
            Bundle currentBundle = bundleEvent.getBundle();
            String appName = AppDeployerUtils.getProjectArtifactName(currentBundle);
            if (bundleEvent.getType() == BundleEvent.RESOLVED && appName != null) {
                appManager.deployCarbonApp(AppDeployerUtils
                        .getArchivePathFromBundle(currentBundle), false);
            }
        } catch (Exception e) {
            log.error("Couldn't deploy Carbon App properly", e);
        }
    }

}
