/*
*  Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
*
*  WSO2 Inc. licenses this file to you under the Apache License,
*  Version 2.0 (the "License"); you may not use this file except
*  in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the License is distributed on an
* "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
* KIND, either express or implied.  See the License for the
* specific language governing permissions and limitations
* under the License.
*/

package org.wso2.carbon.application.deployer;

/**
 * All constants related to app deployer
 */
public class AppDeployerConstants {

    public static final String WSO2_APP_NAME_HEADER = "WSO2-Application-Name";
    public static final String PARENT_APP_HEADER = "ParentApplication";
    public static final String WSO2_APP_DEPLOYER_HEADER = "WSO2-Application-Deployer";
    public static final String DEFAULT_APP = "Default Application";

    //registry constants
    public static final String ROOT = "repository/";
    public static final String APPLICATIONS = ROOT + "applications/";
    public static final String APP_DEPENDENCIES = "/dependencies/";
    public static final String APP_ARTIFACTS_XML = "/artifacts-xml/";
    public static final String ARTIFACT_XML = "/artifact-xml/";
    public static final String REG_CONFIG_XML = "/regconfig-xml/";

    public static final String RESOURCES_DIR = "/resources/";

    public static final String NAME = "name";
    public static final String TYPE = "type";
    public static final String LAST_UPDATED_TIME = "last.updated.time";
    public static final String FILE_NAME = "file.name";
    public static final String APP_FILE_PATH = "app.file.path";
    public static final String RUNTIME_OBJECT_NAME = "runtime.object.name";

    public static final String ARTIFACT_VERSION = "version";
    public static final String ARTIFACT_SERVER_ROLE = "server.role";

    public static final String CARBON_SERVER_ROLE = "ServerRoles.Role";
    public static final String SERVER_ROLES_CMD_OPTION = "serverRoles";

    public static final String CARBON_APPS = "carbonapps";
    public static final String CARBON_PLUGINS = "plugins";
    public static final String CARBON_DROPINS = "dropins";
}
