/*
*  Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
*
*  WSO2 Inc. licenses this file to you under the Apache License,
*  Version 2.0 (the "License"); you may not use this file except
*  in compliance with the License.
*  You may obtain a copy of the License at
*
*    http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the License is distributed on an
* "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
* KIND, either express or implied.  See the License for the
* specific language governing permissions and limitations
* under the License.
*/

package org.wso2.carbon.application.deployer.handler;

import org.wso2.carbon.application.deployer.CarbonApplication;

/**
 * This is the common interface for all App undeployers. Different implementers handle undeployment
 * (deletion) of different artifacts..
 */
public interface AppUndeploymentHandler {

    /**
     * Delete the artifacts which can be deleted through this undeployer.
     * @param carbonApp - all information about the existing artifacts are in this instance
     */
    public void undeployArtifacts(CarbonApplication carbonApp);
}
