package org.wso2.carbon.core.services.authentication;

import java.rmi.RemoteException;

import org.apache.axis2.context.MessageContext;

public interface CarbonServerAuthenticator {

    /**
     * Does this authenticator handle this type of requests
     * 
     * @param request
     * @return
     * @throws RemoteException
     */
    public boolean isHandle(MessageContext msgContext);

    /**
     * Authenticates user based on the credentials contained in the request.
     * 
     * @param request
     * @return
     * @throws AuthenticationException
     */
    public boolean isAuthenticated(MessageContext messageContext);

    /**
     * Gets the priority of this authenticator in the framework
     * 
     * @return
     */
    public int getPriority();

    /**
     * The name of the Authenticator
     * 
     * @return
     */
    public String getAuthenticatorName();

    /**
     * By default all the authenticators found in the system are enabled. Can use this property to
     * control default behavior.
     * 
     * @return
     */
    public boolean isDisabled();
}
