package org.wso2.carbon.ui.clients;

import javax.servlet.http.HttpSession;

import org.apache.axis2.AxisFault;
import org.apache.axis2.client.Options;
import org.apache.axis2.client.ServiceClient;
import org.apache.axis2.context.ConfigurationContext;
import org.apache.axis2.transport.http.HTTPConstants;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.wso2.carbon.core.common.AuthenticationException;
import org.wso2.carbon.core.common.LoggedUserInfo;
import org.wso2.carbon.ui.loggeduserinfo.LoggedUserInfoAdminStub;

public class LoggedUserInfoClient {

    private static final Log log = LogFactory.getLog(LoggedUserInfoClient.class);
    private LoggedUserInfoAdminStub stub;

    public LoggedUserInfoClient(ConfigurationContext ctx, String serverURL, String cookie)
            throws AxisFault {
        String serviceEPR = serverURL + "LoggedUserInfoAdmin";
        stub = new LoggedUserInfoAdminStub(ctx, serviceEPR);
        ServiceClient client = stub._getServiceClient();
        Options options = client.getOptions();
        options.setManageSession(true);
        if (cookie != null) {
            options.setProperty(HTTPConstants.COOKIE_STRING, cookie);
        }
    }

    public LoggedUserInfo getUserInfo() throws Exception {
        try {
            return getLoggedUserInfo(stub.getUserInfo());
        } catch (Exception e) {
            String msg = "Error occurred while getting system permissions of user";
            log.error(msg, e);
            throw new AuthenticationException(msg, e);
        }
    }

    private LoggedUserInfo getLoggedUserInfo(
            org.wso2.carbon.ui.loggeduserinfo.LoggedUserInfo userInfo) {
        LoggedUserInfo loggedUserInfo = new LoggedUserInfo();
        loggedUserInfo.setUIPermissionOfUser(userInfo.getUIPermissionOfUser());
        loggedUserInfo.setPasswordExpiration(userInfo.getPasswordExpiration());
        return loggedUserInfo;
    }

}
