package org.wso2.carbon.user.core.claim;

import org.wso2.carbon.user.core.UserStoreException;

public interface ClaimManager {

    /**
     * {@inheritDoc}
     */
    String getAttributeName(String claimURI) throws UserStoreException;

    /**
     * {@inheritDoc}
     */
    Claim getClaim(String claimURI) throws UserStoreException;

    ClaimMapping getClaimMapping(String claimURI) throws UserStoreException;

    /**
     * {@inheritDoc}
     */
    Claim[] getAllSupportClaimsByDefault() throws UserStoreException;

    /**
     * {@inheritDoc}
     */
    Claim[] getAllClaims() throws UserStoreException;

    /**
     * {@inheritDoc}
     */
    Claim[] getAllClaims(String dialectUri) throws UserStoreException;

    /**
     * {@inheritDoc}
     */
    Claim[] getAllRequiredClaims() throws UserStoreException;

    String[] getAllClaimUris() throws UserStoreException;

    /**
     * {@inheritDoc}
     */
    void addNewClaimMapping(ClaimMapping mapping) throws UserStoreException;

    /**
     * {@inheritDoc}
     */
    void deleteClaimMapping(ClaimMapping mapping) throws UserStoreException;

    /**
     * {@inheritDoc}
     */
    void updateClaimMapping(ClaimMapping mapping) throws UserStoreException;

}