package org.wso2.carbon.user.core.internal;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.osgi.framework.BundleContext;
import org.wso2.carbon.CarbonConstants;
import org.wso2.carbon.user.core.common.DefaultRealmService;
import org.wso2.carbon.user.core.service.RealmService;
import org.wso2.carbon.utils.CarbonUtils;
import org.wso2.carbon.utils.ServerConfiguration;

/**
 * This is one of the first bundles that start in Carbon.
 * 
 * ServerConfiguration object is not available to this bundle.
 * Therefore we read properties but do not keep a reference to it.
 */
public class Activator extends BundleCheckActivator {
    // private static final sun.rmi.runtime.Log log =
    // LogFactory.getLog(Activator.class);
    private static final Log log = LogFactory.getLog(Activator.class);

    private static RealmService realmService = null;

    public void startDeploy(BundleContext bundleContext) throws Exception {

        try {
            RealmService realmService = new DefaultRealmService(bundleContext);
            bundleContext.registerService(RealmService.class.getName(), realmService, null);
            Activator.realmService = realmService;
        } catch (Throwable e) {
            String msg = "Cannot start User Manager Core bundle";
            log.error(msg, e);
            // do not throw exceptions;
        }
    }

    public String getName() {
        return "UserCore";
    }

    public void stop(BundleContext bundleContext) throws Exception {

    }

    public static RealmService getRealmService() {
        return realmService;
    }  
}
