/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */
package org.wso2.carbon.user.core.tenant;

public class TenantConstants {
    public static String ADD_TENANT_SQL = "INSERT INTO UM_TENANT (UM_DOMAIN_NAME," +
            "UM_EMAIL) VALUES(?,?)";
    public static String UPDATE_TENANT_SQL = "UPDATE UM_TENANT SET UM_DOMAIN_NAME=?,UM_EMAIL=?" +
                "WHERE UM_ID=?";
    public static String GET_TENANT_SQL = "SELECT UM_ID, UM_DOMAIN_NAME, UM_EMAIL, UM_ACTIVE FROM " +
                "UM_TENANT WHERE UM_ID=?";
    public static String GET_ALL_TENANTS_SQL = "SELECT UM_ID, UM_DOMAIN_NAME, UM_EMAIL, UM_ACTIVE " +
                "FROM UM_TENANT ORDER BY UM_ID";
    public static String GET_DOMAIN_SQL = "SELECT UM_DOMAIN_NAME FROM UM_TENANT WHERE UM_ID=?";
    public static String GET_TENANT_ID_SQL = "SELECT UM_ID FROM UM_TENANT WHERE UM_DOMAIN_NAME=?";
    public static String ACTIVATE_SQL = "UPDATE UM_TENANT SET UM_ACTIVE=TRUE WHERE UM_ID=?";
    public static String DEACTIVATE_SQL = "UPDATE UM_TENANT SET UM_ACTIVE=FALSE WHERE UM_ID=?";
    public static String IS_TENANT_ACTIVE_SQL = "SELECT UM_ACTIVE FROM UM_TENANT WHERE UM_ID=?";
    public static String DELETE_TENANT_SQL = "DELETE FROM UM_TENANT WHERE UM_ID=?";
}
