package org.wso2.carbon.user.core.tenant;

import org.wso2.carbon.user.core.UserStoreException;
import org.osgi.framework.BundleContext;

public interface TenantManager {

    int addTenant(Tenant tenant) throws UserStoreException;

    void updateTenant(Tenant tenant) throws UserStoreException;

    Tenant getTenant(int tenantId) throws UserStoreException;

    Tenant[] getAllTenants() throws UserStoreException;

    String getDomain(int tenantId) throws UserStoreException;

    int getTenantId(String domain) throws UserStoreException;

    void activateTenant(int tenantId) throws UserStoreException;

    void deactivateTenant(int tenantId) throws UserStoreException;

    boolean isTenantActive(int tenantId) throws UserStoreException;

    void deleteTenant(int tenantId) throws UserStoreException;
    
    String getSuperTenantDomain() throws UserStoreException;

    void setBundleContext(BundleContext bundleContext);

}